'***********************************************************
'* 2-M Rollosteuerung  Hard & Software (c) Fred Redlich    *
'***********************************************************

'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'+ Rollos sollen per Hand AUF oder ZU gefahren werden.     +
'+ Sowie aut. nach Sonneneinstrahlung.                     +
'+ Wichtige Merkmale sind die Stromberwachung und         +
'+ der kurze Rcklauf nach Anschlag um Rollo zu entlasten. +
'+ Helligkeit wird ca. jede Minute gemessen und nach ca.   +
'+ 15 Minuten Auswertung wird Entscheidung getroffen.      +
'+                                                         +
'+     M1auf = Taster Motor1                               +
'+     M1zu = Taster Motor1                                +
'+                                                         +
'+     M2auf = Taster Motor2                               +
'+     M2zu = Taster Motor2                                +
'+                                                         +
'+     K1 und K2 Wenderelais fr Motor 1                   +
'+     K3 und K4 Wenderelais fr Motor 2                   +
'+                                                         +
'+    ------ Analog fr Helligkeit ------                  +
'+     Autom1 = Getadc(2)                                  +
'+     Autom2 = Getadc(3)                                  +
'+                                                         +
'+    ------ Analog fr Strommessung -----                 +
'+     Strom1 = Getadc(1)                                  +
'+     Strom2 = Getadc(0)                                  +
'+                                                         +
'+ werden alle Test-Print gelscht ist Auslastung <25%     +
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

$regfile = "m8def.dat"                                      'ATMega8
$hwstack = 40
$swstack = 40
$framesize = 40
$crystal = 8000000                                          'Fuse Intern (8MHz)
$baud = 19200


Waitms 250

Dim Strom1 As Word
Dim Strom01 As Word
Dim Strom2 As Word
Dim Strom02 As Word
Dim Sz1 As Byte
Dim Sz2 As Byte
Dim Tempword As Word
Dim Helligkeit1(30) As Word
Dim Helligkeit2(30) As Word
Dim Helligkeitsdurchschnitt1 As Long
Dim Helligkeitsdurchschnitt2 As Long
Dim Automzuletztauf1 As Bit
Dim Automzuletztzu1 As Bit
Dim Automzuletztauf2 As Bit
Dim Automzuletztzu2 As Bit
Dim Halteauf1 As Bit
Dim Halteauf2 As Bit
Dim Haltezu1 As Bit
Dim Haltezu2 As Bit
Dim Halteaus1 As Byte
Dim Halteaus2 As Byte
Dim Schleifenzaehler As Word
Dim Schleifenzaehler2 As Byte
Dim I As Byte

'Werte anpassen !!!
Const Helligkeitmittel = 50
Const Helligkeitdunkel = 70
Const Helligkeithell = 30

Config Adc = Single , Prescaler = Auto , Reference = Avcc
Start Adc

'--------------Alias fr Taster------------------------------
Config Pind.2 = Input
Portd.2 = 1
M1auf Alias Pind.2                                          ' Eingang

Config Pind.3 = Input
Portd.3 = 1
M1zu Alias Pind.3

Config Pind.4 = Input
Portd.4 = 1
M2auf Alias Pind.4

Config Pind.5 = Input
Portd.5 = 1
M2zu Alias Pind.5


'--------------Alias fr Relais------------------------------
Config Portb.1 = Output
K1 Alias Portb.1                                            ' ausgang

Config Portb.0 = Output
K2 Alias Portb.0

Config Portd.7 = Output
K3 Alias Portd.7

Config Portd.6 = Output
K4 Alias Portd.6

'************************************************************************

' Helligkeiten mit mittelerem Wert befllen
For I = 1 To 30
    Helligkeit1(i) = Helligkeitmittel
    Helligkeit2(i) = Helligkeitmittel
Next I
Helligkeitsdurchschnitt1 = Helligkeitmittel
Helligkeitsdurchschnitt2 = Helligkeitmittel

Set K1                                                      'alle Relais abschalten
Set K2
Set K3
Set K4
Strom1 = Getadc(1)
Strom2 = Getadc(0)

Halteaus1 = 10
Halteaus2 = 10


'--------------Haubtschleife-----------------------
Do
  'Strom1 = Getadc(1)
  'Print "Strom1  " ; Strom1

  Schleifenzaehler = Schleifenzaehler + 1
  If Schleifenzaehler = 60 Then                             ' spter 600 !!!       ' etwa alle 1 Minuten
     If Schleifenzaehler2 < 30 Then
        Schleifenzaehler2 = Schleifenzaehler2 + 1
     Else
        Schleifenzaehler2 = 1
     End If
     Print "SZ2: " ; Schleifenzaehler2

     ' helligkeit messen und durchschnitt ber die letzten 30 werte bilden
     Helligkeit1(schleifenzaehler2) = Getadc(3)
     Helligkeit2(schleifenzaehler2) = Getadc(2)
     Print "aktuelle Helligkeit: " ; Helligkeit1(schleifenzaehler2) ; " " ; Helligkeit2(schleifenzaehler2)
     For I = 1 To 30
        Helligkeitsdurchschnitt1 = Helligkeitsdurchschnitt1 + Helligkeit1(i)
        Helligkeitsdurchschnitt2 = Helligkeitsdurchschnitt2 + Helligkeit2(i)
     Next I
     Helligkeitsdurchschnitt1 = Helligkeitsdurchschnitt1 / 30
     Helligkeitsdurchschnitt2 = Helligkeitsdurchschnitt2 / 30

     Print "Helligkeitsdurchschnitt: " ; Helligkeitsdurchschnitt1 ; " " ; Helligkeitsdurchschnitt2

     Schleifenzaehler = 0
  End If                                                    ' ende schleifenzhler



'--------------------------------

  If Halteaus1 > 0 Then
     Halteaus1 = Halteaus1 - 1
  Else
      '----fr Motor 1 -- Sensor -----

    If Automzuletztzu1 = 0 And Helligkeitsdurchschnitt1 < Helligkeithell And Haltezu1 = 0 And Halteauf1 = 0 Then       'ist es sehr Hell wird virtuel Taste ZU gedrckt
       Print "Auto zu 1"
       Haltezu1 = 1
       Halteauf1 = 0
       Automzuletztzu1 = 1
       Automzuletztauf1 = 0
    Elseif Automzuletztauf1 = 0 And Helligkeitsdurchschnitt1 > Helligkeitdunkel And Haltezu1 = 0 And Halteauf1 = 0 Then       'ist es nicht Hell wird virtuel Taste AUF gedrckt
       Print "Auto auf 1"
       Haltezu1 = 0
       Halteauf1 = 1
       Automzuletztzu1 = 0
       Automzuletztauf1 = 1
    End If

    '----fr Motor 1 -- Taste-------
    If M1auf = 0 And Haltezu1 = 0 And Halteauf1 = 0 Then    'ist Taster kurz bettigt fahr auf
      Print "Man auf 1"
      Halteauf1 = 1                                         'Hilfsvariable
      Haltezu1 = 0
      'Automzuletztzu1 = 0
    Elseif M1zu = 0 And Haltezu1 = 0 And Halteauf1 = 0 Then
      Print "Man zu 1"
      Halteauf1 = 0
      Haltezu1 = 1
      'Automzuletztauf1 = 0
    End If


    If Halteauf1 = 1 Then                                   'Motor 1 Laufrichtung AUF
        If M1zu = 0 Then                                    'wenn Taste ZU dann anhalten
           Set K1
           Halteauf1 = 0
           Halteaus1 = 20
        Else
            Reset K1                                        'Motor 1 einschalten
            Strom1 = Getadc(1)                              'Strom messen
            Waitms 100
            Print "auf Strom1  " ; Strom1
            If Strom1 > 635 Then                            'Strom Max einstellen
                 Halteauf1 = 0                              'ist Max erreicht halte an
                 Halteaus1 = 20
                 Print "Motor1 abschalten"
                 Set K1
                 Wait 1                                     'warte
                 Reset K2                                   'Motor 1 Richtung umschalten
                 Waitms 600                                 'dreht 500ms in andere Richtung
                 Set K2                                     'halte an
                 Strom1 = 0                                 'Strommessung auf Null setzen
            End If
        End If
    End If


  '--- Fr andere Richtung

    If Haltezu1 = 1 Then
           If M1auf = 0 Then
           Set K2
           Haltezu1 = 0
           Halteaus1 = 20
        Else
            Reset K2
            Strom1 = Getadc(1)                              'Strom messen
            Waitms 100
            Print "zu Strom1  " ; Strom1
            If Strom1 > 625 Then
               Haltezu1 = 0
               Halteaus1 = 20
               Print "Motor1 abschalten"
               Set K2
               Wait 1
               Reset K1
               Waitms 620
               Set K1
               Strom1 = 0
            End If
        End If
     End If
  End If



  If Halteaus2 > 0 Then
     Halteaus2 = Halteaus2 - 1
  Else

  '----fr Motor 2 -- Sensor -----

    If Automzuletztzu2 = 0 And Helligkeitsdurchschnitt2 < Helligkeithell And Halteauf2 = 0 And Haltezu2 = 0 Then       'ist es sehr Hell wird virtuel Taste ZU gedrckt
       Print "Auto zu 2"
       Haltezu2 = 1
       Halteauf2 = 0
       Automzuletztzu2 = 1
       Automzuletztauf2 = 0
    Elseif Automzuletztauf2 = 0 And Helligkeitsdurchschnitt2 > Helligkeitdunkel And Halteauf2 = 0 And Haltezu2 = 0 Then       'ist es nicht Hell wird virtuel Taste AUF gedrckt
       Print "Auto auf 2"
       Haltezu2 = 0
       Halteauf2 = 1
       Automzuletztzu2 = 0
       Automzuletztauf2 = 1
    End If

   '----fr Motor 2 -- Taste-------
    If M2auf = 0 And Halteauf2 = 0 And Haltezu2 = 0 Then    'ist Taster kurz bettigt fahr auf
      Print "Man auf 2"
      Halteauf2 = 1                                         'Hilfsvariable
      Haltezu2 = 0
      'Automzuletztzu2 = 0
    Elseif M2zu = 0 And Halteauf2 = 0 And Haltezu2 = 0 Then
      Print "Man zu 2"
      Halteauf2 = 0
      Haltezu2 = 1
      'Automzuletztauf2 = 0
    End If


    If Halteauf2 = 1 Then                                   'Motor 2 Laufrichtung AUF
        If M2zu = 0 Then
           Print "Motor2 man abschalten"                    'wenn Taste ZU dann anhalten
           Set K3
           Halteauf2 = 0
           Halteaus2 = 20
        Else                                                'Motor 2 einschalten
            Reset K3
            Strom2 = Getadc(0)                              'Strom messen
            Waitms 100
            Print "auf Strom2  " ; Strom2
            If Strom2 > 635 Then                            'Strom Max einstellen
                 Halteauf2 = 0                              'ist Max erreicht halte an
                 Halteaus2 = 20
                 Print "Motor2 abschalten"
                 Set K3
                 Wait 1                                     'warte
                 Reset K4                                   'Motor 2 Richtung umschalten
                 Waitms 600                                 'dreht 500ms in andere Richtung
                 Set K4                                     'halte an
                 Strom2 = 0                                 'Strommessung auf Null setzen
            End If
        End If
    End If


  '--- Fr andere Richtung

    If Haltezu2 = 1 Then
        If M2auf = 0 Then
           Print "Motor2 man abschalten"
           Set K4
           Haltezu2 = 0
           Halteaus2 = 20
        Else
            Reset K4
            Strom2 = Getadc(0)
            Waitms 100
            Print "zu Strom2  " ; Strom2
            If Strom2 > 625 Then
               Haltezu2 = 0
               Halteaus2 = 20
               Print "Motor2 abschalten"
               Set K4
               Wait 1
               Reset K3
               Waitms 620
               Set K3
               Strom2 = 0
            End If
        End If
     End If
  End If



' immer kurz warten
  Waitms 100
Loop